﻿Configuration InstallAgent
{
    param($Nodename)
    
    $userName = "SampleUserName" #<Enter the userName>
    $password = "SamplePwd" #<Enter the password>
    $apikey = "sampleDeviceKey" #<Copy the device key from Site24x7 client>
    $enableProxy = "NO" #<YES/NO to enable proxy>
    $proxyServerName = "" #<proxyservername:port>
    $proxyUserName = "" #<proxyusername> 
    $proxyPassword = "" #<proxypassword>

    $secpasswd = ConvertTo-SecureString $password -AsPlainText -Force
    $mycreds = New-Object System.Management.Automation.PSCredential ($userName, $secpasswd)

    Node $Nodename
    {
         $args = "EDITA1=" + $apikey +" ENABLESILENT=YES INSTALLATIONTYPE=DSC_WINDOWS REBOOT=ReallySuppress"
        if($enableProxy -eq "YES")
        {
            $args = $args + " ENABLEPROXY=yes" + " ProxyServerName=" + $proxyServerName + " ProxyUserName=" + $proxyUserName + " ProxyPassword=" + $proxyPassword
        }

        File msiCopy
        {
            DestinationPath = $env:temp + "\Site24x7WindowsAgent.msi" #"C:\Users\SITE24X7\Desktop\Site24x7WindowsAgent.msi"
            SourcePath = "\\"+$env:computername+"\msiShare\Site24x7WindowsAgent.msi"
            Ensure = "Present"
            Type = "File"
            Credential = $myCreds
            Checksum = "modifiedDate"
            Force = $true
        }

         Package InstallAgent
        {
            Ensure = 'Present'
            Name = 'Site24x7 Windows Agent'
            Path = $env:temp + "\Site24x7WindowsAgent.msi"
            ProductID = '{0C16B7BE-0473-4345-B182-E61A209699D4}'
            Arguments = $args       
        }
    }
}

IMPORT-CSV .\hostnames.csv | FOREACH { 

$cd = @{
    AllNodes = @(
        @{
            NodeName = $_.HostName
            PsDscAllowPlainTextPassword = $true
        }
    ) 
}

InstallAgent –nodename $_.HostName -ConfigurationData $cd
}

